## coin3 4.0.0~CMake~6f54f1602475+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(COIN_MAJOR_VERSION 4)
set(COIN_MINOR_VERSION 0)
set(COIN_MICRO_VERSION 0)
set(COIN_BETA_VERSION a)
set(COIN_VERSION ${COIN_MAJOR_VERSION}.${COIN_MINOR_VERSION}.${COIN_MICRO_VERSION}${COIN_BETA_VERSION})

project(Coin VERSION ${COIN_MAJOR_VERSION}.${COIN_MINOR_VERSION}.${COIN_MICRO_VERSION})
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

string(TIMESTAMP COIN_BUILD_YEAR "%Y")
math(EXPR COIN_SO_VERSION ${PROJECT_VERSION_MAJOR}*20)

# ############################################################################
# these will be removed after upgrading CMake minimum version
set(PROJECT_DESCRIPTION   "A high-level 3D visualization library with Open Inventor 2.1 API")
# ############################################################################

if(POLICY CMP0072)
  # get rid of OpenGL GLVND warning from CMake 3.11
  cmake_policy(SET CMP0072 NEW)
endif()

# ############################################################################
# Prevent insource builds, as they often cause severe build problems
# ############################################################################

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "${CMAKE_PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake <path_to_${CMAKE_PROJECT_NAME}> [options]' from there.")
endif()

# ############################################################################
# Include necessary submodules
# ############################################################################

# Add path for Coin specific utility scripts
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

include(CheckCSourceRuns)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckTypeSize)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(FeatureSummary)
include(CoinCMakeUtilities)

# ############################################################################
# Provide options to customise the build
# ############################################################################

option(COIN_BUILD_SHARED_LIBS "Build shared library when ON (default), static when OFF." ON)
option(COIN_BUILD_TESTS "Build unit tests when ON (default), skips them when OFF." ON)
option(COIN_BUILD_DOCUMENTATION "Build and install API documentation (requires Doxygen)." ON)
cmake_dependent_option(COIN_BUILD_INTERNAL_DOCUMENTATION "Document internal code not part of the API." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_MAN "Build Coin man pages." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_QTHELP "Build QtHelp documentation." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_CHM "Build compressed HTML help manual (requires HTML help compiler)" OFF "COIN_BUILD_DOCUMENTATION" OFF)

option(COIN_THREADSAFE "Enable thread safe render traversals." OFF)
option(HAVE_VRML97 "Enable VRML97 support." ON)
cmake_dependent_option(COIN_HAVE_JAVASCRIPT "Enable JavaScript capabilities for VRML97." ON "HAVE_VRML97" OFF)
option(HAVE_NODEKITS "Enable NodeKit support." ON)
cmake_dependent_option(HAVE_DRAGGERS "Enable Dragger support." ON "HAVE_NODEKITS" OFF)
cmake_dependent_option(HAVE_MANIPULATORS "Enable Manipulator support." ON "HAVE_NODEKITS" OFF)
option(HAVE_SOUND "Enable OpenAL sound support." ON)
option(HAVE_3DS_IMPORT_CAPABILITIES "Enable 3ds import capabilities." ON)
option(USE_EXTERNAL_EXPAT "Use system install of Expat." OFF)
option(USE_EXCEPTIONS "Compile with exceptions (g++ only)." ON)
option(USE_SUPERGLU "Use superglu library when ON, GLU implementation of platform when OFF (default)." OFF)

option(FONTCONFIG_RUNTIME_LINKING   "Enable FontConfig runtime linking when ON (default), disable when OFF." ON)
option(FREETYPE_RUNTIME_LINKING     "Enable FreeType runtime linking when ON (default), disable when OFF." ON)
option(LIBBZIP2_RUNTIME_LINKING     "Enable libBZip2 runtime linking when ON (default), disable when OFF." ON)
option(OPENAL_RUNTIME_LINKING       "Enable OpenAL runtime linking when ON (default), disable when OFF." ON)
option(SIMAGE_RUNTIME_LINKING       "Enable simage runtime linking when ON (default), disable when OFF" ON)
option(ZLIB_RUNTIME_LINKING         "Enable ZLib runtime linking when ON (default), disable when OFF." ON)
option(GLU_RUNTIME_LINKING          "Enable GLU runtime linking when ON (default), disable when OFF." ON)
option(SPIDERMONKEY_RUNTIME_LINKING "Enable SpiderMonkey runtime linking when ON (default), disable when OFF." ON)

option(COIN_VERBOSE "Add verbose debugging information during the configure process." OFF)
option(HAVE_MULTIPLE_VERSION "Forces versioned paths for includes and documentation when ON, usual behaviour otherwise." OFF)

if(HAVE_MULTIPLE_VERSION)
  # Modifies the installation path for both the distributed includes and docs
  versionize(INCLUDEDIR DOCDIR)
  dump_variable(CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_FULL_INCLUDEDIR CMAKE_INSTALL_DOCDIR CMAKE_INSTALL_FULL_DOCDIR)
endif()

# ############################################################################
# Find all necessary and optional Coin3D dependencies
# ############################################################################

# Fail early if one of the required packages cannot be found

# This is needed when Coins local Boost includes are removed and system installation of Boost is used.
#find_package(Boost REQUIRED) # almost any Boost will do
#list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIRS})

# As not all CMake FindXXX modules and config packages provide target support,
# we should explicitly check for them on.
find_package(OpenGL REQUIRED)
if(OPENGL_FOUND)
  set(HAVE_OPENGL 1)
  set(OPENGL_SYSTEM_LIBRARY_NAME "${OPENGL_gl_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX}")
  if(OpenGL_GLU_FOUND)
    set(HAVE_GLU 1)
  endif()
  if(APPLE)
    set(GLU_IS_PART_OF_GL 1)
  endif()
  #include_directories("${OPENGL_INCLUDE_DIR}")
  if (NOT TARGET OpenGL::GL)
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${OPENGL_INCLUDE_DIR}")
    list(APPEND COIN_TARGET_LINK_LIBRARIES "${OPENGL_gl_LIBRARY}" "${OPENGL_glu_LIBRARY}")
  else()
    list(APPEND COIN_TARGET_LINK_LIBRARIES OpenGL::GL OpenGL::GLU)
  endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
if(Threads_FOUND)
  set(HAVE_THREADS 1)
  if(CMAKE_USE_WIN32_THREADS_INIT)
    set(USE_W32THREAD 1)
    set(COIN_THREADID_TYPE DWORD)
  elseif(CMAKE_USE_PTHREADS_INIT)
    set(USE_PTHREAD 1)
    set(COIN_THREADID_TYPE pthread_t)
  endif()
  #include_directories("${THREADS_INCLUDE_DIRS}")
  if (NOT TARGET Threads::Threads)
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${THREADS_INCLUDE_DIRS}")
    list(APPEND COIN_TARGET_LINK_LIBRARIES "${CMAKE_THREAD_LIBS_INIT}")
  else()
    list(APPEND COIN_TARGET_LINK_LIBRARIES Threads::Threads)
  endif()
endif()

if(USE_EXTERNAL_EXPAT)
  find_package(EXPAT)
  if(EXPAT_FOUND)
    set(HAVE_EXPAT 1)
    #include_directories("${EXPAT_INCLUDE_DIRS}")
    if (NOT TARGET EXPAT::EXPAT)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${EXPAT_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${EXPAT_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES EXPAT::EXPAT)
    endif()
  endif()
else()
  if(NOT WIN32)
    set(XML_DEV_URANDOM 1)
  endif()
endif()

if(USE_SUPERGLU)
  find_package(superglu)
  if(superglu_FOUND)
    set(HAVE_SUPERGLU 1)
    set(GLU_RUNTIME_LINKING OFF)
    list(REMOVE_ITEM COIN_TARGET_LINK_LIBRARIES "${OPENGL_glu_LIBRARY}")
    if(TARGET OpenGL::GLU)
      list(REMOVE_ITEM COIN_TARGET_LINK_LIBRARIES OpenGL::GLU)
    endif()
    list(APPEND COIN_TARGET_LINK_LIBRARIES superglu::GLU)
  endif()
endif()

#find_package(FLEX)
#if(FLEX_FOUND)
# set(HAVE_FLEX 1)
# #include_directories("${FLEX_INCLUDE_DIRS}")
# #list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${FLEX_INCLUDE_DIRS}")
#endif()
#
#find_package(BISON)
#if(BISON_FOUND)
# set(HAVE_BISON 1)
# #include_directories("${BISON_INCLUDE_DIRS}")
# #list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${BISON_INCLUDE_DIRS}")
#endif()

if(HAVE_SOUND)
  if(NOT OPENAL_RUNTIME_LINKING)
    find_package(OpenAL)
    if(OpenAL_FOUND)
      set(HAVE_OPENAL 1)
      #include_directories("${OPENAL_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${OPENAL_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${OPENAL_LIBRARY}")
      # Checks specific OpenAL configurations
      set(CMAKE_REQUIRED_INCLUDES "${OPENGL_INCLUDE_DIR}")
      check_include_file(AL/al.h HAVE_AL_AL_H)
      check_include_file(OpenAL/al.h HAVE_OPENAL_AL_H)
      set(CMAKE_REQUIRED_INCLUDES)
    endif()
  endif()
endif()

if(NOT ZLIB_RUNTIME_LINKING)
  find_package(ZLIB)
  if(ZLIB_FOUND)
    set(HAVE_ZLIB 1)
    #include_directories("${ZLIB_INCLUDE_DIRS}")
    if (NOT TARGET ZLIB::ZLIB)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${ZLIB_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${ZLIB_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES ZLIB::ZLIB)
    endif()
  endif()
endif()

if(NOT LIBBZIP2_RUNTIME_LINKING)
  find_package(BZip2)
  if(BZip2_FOUND)
    set(HAVE_BZIP2 1)
    #include_directories("${BZIP2_INCLUDE_DIRS}")
    if (NOT TARGET BZip2::BZip2)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${BZIP2_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${BZIP2_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES BZip2::BZip2)
    endif()
  endif()
endif()

if(NOT FREETYPE_RUNTIME_LINKING)
  find_package(Freetype)
  if(Freetype_FOUND)
    set(HAVE_FREETYPE 1)
    #include_directories("${FREETYPE_INCLUDE_DIRS}")
    if (NOT TARGET Freetype::Freetype)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${FREETYPE_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${FREETYPE_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES Freetype::Freetype)
    endif()
    set(HAVE_FREETYPE_H 1)
  endif()
endif()

if(NOT FONTCONFIG_RUNTIME_LINKING)
  find_package(Fontconfig)
  if(FONTCONFIG_FOUND)
    set(HAVE_FONTCONFIG 1)
    #include_directories("${FONTCONFIG_INCLUDE_DIR}")
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${FONTCONFIG_INCLUDE_DIR}")
    list(APPEND COIN_TARGET_LINK_LIBRARIES "${FONTCONFIG_LIBRARY}")
    set(HAVE_FONTCONFIG_H 1)
  endif()
endif()

if(HAVE_VRML97 AND COIN_HAVE_JAVASCRIPT)
  if(NOT SPIDERMONKEY_RUNTIME_LINKING)
    find_package(SpiderMonkey)
    if(SPIDERMONKEY_FOUND)
      set(HAVE_SPIDERMONKEY_VIA_LINKTIME_LINKING 1)
      #include_directories("${SPIDERMONKEY_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${SPIDERMONKEY_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${SPIDERMONKEY_LIBRARIES}")
      set(HAVE_SPIDERMONKEY_H 1)
    endif()
  endif()
endif()

if(NOT SIMAGE_RUNTIME_LINKING)
  find_package(simage)
  if(simage_FOUND)
    set(HAVE_LIBSIMAGE 1)
    list(APPEND COIN_TARGET_LINK_LIBRARIES simage::simage)
  endif()
endif()

message(STATUS "${COIN_TARGET_INCLUDE_DIRECTORIES}")
message(STATUS "${COIN_TARGET_LINK_LIBRARIES}")

# ##########################################################################
# Setup build environment
# ##########################################################################

if(NOT CMAKE_BUILD_TYPE)
  # Has no effect for multi configuration generators (VisualStudio, Xcode).
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose type of build, options are Debug, Release, RelWithDebInfo, MinSizeRel." FORCE)
endif()
# Set common output directories for all targets built.
# First for the generic no-config case (e.g. with mingw)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
# Second, for multi-config builds (e.g. msvc)

=== data/CMakeLists.txt ===
macro(strfy input postfx)
	get_filename_component(FLNAME "${input}" NAME_WE)
	get_filename_component(FLEXT "${input}" EXT)
	get_filename_component(FLPATH "${input}" PATH)
	string(SUBSTRING ${FLEXT} 1 -1 FLEXT)
	string(TOUPPER "SO_${FLNAME}_${FLEXT}_H" COIN_HEADER_DEF)
	string(TOUPPER ${FLNAME} COIN_TEXTVAR_NAME)
	set(COIN_TEXTVAR_NAME "${COIN_TEXTVAR_NAME}${postfx}")
	#message(STATUS "Parse: ${CMAKE_SOURCE_DIR}/${input}")
	FILE(READ ${CMAKE_SOURCE_DIR}/${input} f0)
	STRING(REGEX REPLACE "\\\\" "\\\\\\\\" f1 "${f0}")
	STRING(REGEX REPLACE "\"" "\\\\\"" f2 "${f1}")
	STRING(REGEX REPLACE "\r?\n" "\\\\n\"\n  \"" COIN_STR_SOURCE_CODE "${f2}")
	configure_file(strfytemplate.cmake.in "${FLPATH}/${FLNAME}.h")
endmacro()

file(GLOB_RECURSE COIN_SHADER_GLSL RELATIVE ${CMAKE_SOURCE_DIR} *.glsl)
foreach(INPUTFILE ${COIN_SHADER_GLSL})
    strfy(${INPUTFILE} "_shadersource")
endforeach(INPUTFILE)
file(GLOB_RECURSE COIN_SHADER_INVENTOR RELATIVE ${CMAKE_SOURCE_DIR} *.iv)
foreach(INPUTFILE ${COIN_SHADER_INVENTOR})
    strfy(${INPUTFILE} "_draggergeometry")
endforeach(INPUTFILE)

=== include/CMakeLists.txt ===
add_subdirectory(Inventor)
install(DIRECTORY Inventor/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Inventor COMPONENT development FILES_MATCHING PATTERN "*.h")
install(FILES SoWinEnterScope.h SoWinLeaveScope.h SoDebug.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT development)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${CMAKE_SOURCE_DIR}/include/SoDebug.h
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== src/CMakeLists.txt ===
# The following two-stage generation of config.h replaces configure_file(config.h.cmake.in config.h)
# and is necessary for the proper definition of COIN_SYSTEM_LIBRARY_NAME in config.h.
# Ref. https://public.kitware.com/pipermail/cmake/2015-April/060350.html
# Deal with @...@ configurable items:
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h_at_configured"
    @ONLY
    )
# Deal with items configured with generator expressions:
  file(GENERATE
    OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
    INPUT
    "${CMAKE_CURRENT_BINARY_DIR}/config.h_at_configured"
    )
configure_file(setup.h.cmake.in setup.h)

add_definitions(-DCOIN_INTERNAL -DHAVE_CONFIG_H)

add_compile_options(-DCOIN_DEBUG=$<CONFIG:Debug>)

include_directories(BEFORE
  "${CMAKE_BINARY_DIR}/include"
  "${CMAKE_SOURCE_DIR}/include"
  "${CMAKE_CURRENT_BINARY_DIR}"
  "${CMAKE_CURRENT_SOURCE_DIR}"
  "${CMAKE_SOURCE_DIR}/include/Inventor/annex"
  "${CMAKE_BINARY_DIR}/data"
)

# add include dirs for non targets
if(NOT "${COIN_TARGET_INCLUDE_DIRECTORIES}" STREQUAL "")
  include_directories("${COIN_TARGET_INCLUDE_DIRECTORIES}")
endif()
# add include dirs for targets
foreach(tgt ${COIN_TARGET_LINK_LIBRARIES})
  if(TARGET ${tgt} )
    include_directories($<TARGET_PROPERTY:${tgt},INTERFACE_INCLUDE_DIRECTORIES>)
  endif()
endforeach()

set(COIN_SOURCE tidbits.cpp CACHE INTERNAL "COIN_SOURCE")
set(SUBDIRS
  extensions xml actions base bundles caches details draggers elements
  engines errors events fields fonts glue io manips misc rendering lists nodekits
  navigation nodes shapenodes projectors sensors upgraders
  3ds collision hardcopy shadows geo threads shaders profiler
  vrml97 foreignfiles scxml soscxml
)

foreach(SUBDIR ${SUBDIRS})
  add_subdirectory(${SUBDIR})
endforeach()
add_subdirectory(doc)

if(COIN_BUILD_SHARED_LIBS)
  set(COIN_LIBRARY_TYPE SHARED)
  if(WIN32)
    configure_file(${PROJECT_NAME}.rc.cmake.in ${PROJECT_NAME}.rc)
    set(COIN_SOURCE ${COIN_SOURCE} "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.rc")
  endif()
else()
  set(COIN_LIBRARY_TYPE STATIC)
endif()

if(COIN_BUILD_SINGLE_LIB)
  add_library(${PROJECT_NAME} ${COIN_LIBRARY_TYPE} tidbits.cpp ${COIN_SOURCE})
else()
  if(NOT HAVE_EXPAT)
    set(expat_target $<TARGET_OBJECTS:expat>)
  endif()

  add_library(${PROJECT_NAME} ${COIN_LIBRARY_TYPE} tidbits.cpp
    $<TARGET_OBJECTS:3ds>
    $<TARGET_OBJECTS:actions>
    $<TARGET_OBJECTS:base>
    $<TARGET_OBJECTS:bundles>
    $<TARGET_OBJECTS:caches>
    $<TARGET_OBJECTS:collision>
    $<TARGET_OBJECTS:details>
    $<TARGET_OBJECTS:draggers>
    $<TARGET_OBJECTS:elements>
    $<TARGET_OBJECTS:engines>
    $<TARGET_OBJECTS:errors>
    $<TARGET_OBJECTS:events>
    ${expat_target}
    $<TARGET_OBJECTS:fields>
    $<TARGET_OBJECTS:fonts>
    $<TARGET_OBJECTS:foreignfiles>
    $<TARGET_OBJECTS:geo>
    $<TARGET_OBJECTS:glelements>
    $<TARGET_OBJECTS:glue>
    $<TARGET_OBJECTS:hardcopy>
    $<TARGET_OBJECTS:io>
    $<TARGET_OBJECTS:lists>
    $<TARGET_OBJECTS:manips>
    $<TARGET_OBJECTS:misc>
    $<TARGET_OBJECTS:navigation>
    $<TARGET_OBJECTS:nodekits>
    $<TARGET_OBJECTS:nodes>
    $<TARGET_OBJECTS:profiler>
    $<TARGET_OBJECTS:projectors>
    $<TARGET_OBJECTS:rendering>
    $<TARGET_OBJECTS:scxml>
    $<TARGET_OBJECTS:sensors>
    $<TARGET_OBJECTS:shaders>
    $<TARGET_OBJECTS:shadows>
    $<TARGET_OBJECTS:shapenodes>
    $<TARGET_OBJECTS:soscxml>
    $<TARGET_OBJECTS:threads>
    $<TARGET_OBJECTS:upgraders>
    $<TARGET_OBJECTS:vrml97>
    $<TARGET_OBJECTS:xml>
    ${COIN_SOURCE}
  )
endif()

if(WIN32)
  if(COIN_BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} INTERFACE COIN_DLL)
  else()
    target_compile_definitions(${PROJECT_NAME} INTERFACE COIN_NOT_DLL)
  endif()
endif()

if(MSVC)
  if(NOT COIN_BUILD_SHARED_LIBS)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Z7")                       # Override default /Zi to embed
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Z7")     # debugging info in the .lib.
  endif()
  # Suppress warning about empty switch statement in Bison-generated files:
  set_property(SOURCE scxml/eval-minimum-tab.cpp APPEND PROPERTY COMPILE_FLAGS /wd4065)
  set_property(SOURCE soscxml/eval-coin-tab.cpp APPEND PROPERTY COMPILE_FLAGS /wd4065)
endif()

target_include_directories(${PROJECT_NAME} PRIVATE "${COIN_TARGET_INCLUDE_DIRECTORIES}")
target_link_libraries(${PROJECT_NAME} PRIVATE "${COIN_TARGET_LINK_LIBRARIES}")
target_include_directories(${PROJECT_NAME} INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>)

set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${COIN_SO_VERSION})

# ############################################################################
# Install binaries and config package
# ############################################################################

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime NAMELINK_SKIP
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development
)

if(COIN_BUILD_SHARED_LIBS)
  install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development NAMELINK_ONLY)
  if(MSVC)
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${CMAKE_INSTALL_BINDIR} CONFIGURATIONS Debug RelWithDebInfo COMPONENT debug)
  endif()
endif()

# Support find_package(Coin NO_MODULE).
set(COIN_DOC_DIR ${CMAKE_INSTALL_DOCDIR})
set(COIN_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(COIN_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
set(COINDIR ${CMAKE_INSTALL_PREFIX})
include(CMakePackageConfigHelpers)

configure_package_config_file(${PROJECT_NAME_LOWER}-config.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config.cmake"
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
  PATH_VARS COINDIR COIN_INCLUDE_DIR COIN_LIB_DIR COIN_DOC_DIR
)

write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config-version.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
)

# To make the component usable not only from the install directory but also from the build directory
export(
  TARGETS ${PROJECT_NAME}
  FILE ${PROJECT_NAME_LOWER}-export.cmake
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config-version.cmake"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
  COMPONENT development
)

install(EXPORT ${PROJECT_NAME}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
  NAMESPACE ${PROJECT_NAME}::
  FILE ${PROJECT_NAME_LOWER}-export.cmake
  COMPONENT development
)

=== testsuite/CMakeLists.txt ===
macro(create_testsuite input)
	get_filename_component(FLNAME "${input}" NAME_WE)
	get_filename_component(FLPATH "${input}" PATH)
	string(REGEX REPLACE ".*[/\\]" "" FLSUBFLD "${FLPATH}")
	set(COIN_STR_TEST_CLASS "${FLNAME}")
	file(READ ${CMAKE_SOURCE_DIR}/${input} f0)
	if(f0 MATCHES "#ifdef[ \t]+COIN_TEST_SUITE")
		# message(STATUS "Parse: ${CMAKE_SOURCE_DIR}/${input} - ${FLPATHSUB}${FLNAME}Test.cpp")
		# get first include from file, which we assume is include to tested class
		string(REGEX MATCH "[\n\r]+#include[ \t]<[^\n]+" iclass "${f0}")
		# get block between '#ifdef COIN_TEST_SUITE' and '#endif'
		string(REGEX REPLACE ".*#ifdef[ \t]+COIN_TEST_SUITE" "" f1 "${f0}")
		string(REGEX REPLACE "#endif[ \t/!]+COIN_TEST_SUITE.*" "" f2 "${f1}")
		# get all #include statements within COIN_TEST_SUITE code block
		string(REGEX MATCHALL "#include[ \t]<[^\n]+" i0 "${f2}")
		string(REPLACE ";" "\n" COIN_STR_TEST_INCL "${i0}")
		set(COIN_STR_TEST_INCL "${iclass}\n${COIN_STR_TEST_INCL}")
		# remove #include statements from test code string (moved to ${COIN_STR_TEST_INCL})
		string(REGEX REPLACE "[\n\r ]*#include[ \t]<[^\n]+" "" COIN_STR_TEST_CODE "${f2}")
		# generate new test code file with extracted snippets
		configure_file(TestSuiteTemplate.cmake.in "${FLSUBFLD}${FLNAME}Test.cpp")
	endif()
endmacro()

macro(create_file_test input testfunc filter)
	file(GLOB_RECURSE COIN_IV_FILES RELATIVE ${CMAKE_SOURCE_DIR} ../${input}/*.wrl ../${input}/*.vrml ../${input}/*.gz ../${input}/*.iv)
	string(REGEX REPLACE "[\\./\\-]+" "" TESTSUITENAME "${input}")
	set(COIN_STR_TEST_INCL "")
	set(COIN_STR_TEST_CODE "const char *readError[] = { \"Coin read error:\", 0 };\n")
	set(COIN_STR_TEST_CLASS "${TESTSUITENAME}")
	set(extra_macro_args ${ARGN})
	list(LENGTH extra_macro_args num_extra_args)
	foreach(INPUTFILE ${COIN_IV_FILES})
		if(${num_extra_args} EQUAL 0 OR NOT ("${INPUTFILE}" MATCHES "${extra_macro_args}"))
			string(REGEX REPLACE "[\\./\\-]+" "_" TESTNAME "${INPUTFILE}")
			if (${filter})
				set(COIN_STR_TEST_CODE "${COIN_STR_TEST_CODE}\nBOOST_AUTO_TEST_CASE(${TESTNAME}) { PushMessageSuppressFilters(readError); ResetReadErrorCount(); test_file(\"${CMAKE_SOURCE_DIR}/${INPUTFILE}\", &${testfunc}); PopMessageSuppressFilters(); }")
			else()
				set(COIN_STR_TEST_CODE "${COIN_STR_TEST_CODE}\nBOOST_AUTO_TEST_CASE(${TESTNAME}) { ResetReadErrorCount(); test_file(\"${CMAKE_SOURCE_DIR}/${INPUTFILE}\", &${testfunc}); }")
			endif()
		endif()
	endforeach()
	configure_file(TestSuiteTemplate.cmake.in "${TESTSUITENAME}Test.cpp")
endmacro()

# Parse all source files for embedded '#ifdef COIN_TEST_SUITE' and extract those blocks
# to separate test source files.
file(GLOB_RECURSE COIN_SRC_FILES RELATIVE ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/*.cpp)
foreach(INPUTFILE ${COIN_SRC_FILES})
	create_testsuite(${INPUTFILE})
endforeach()

# Create test cases for all scenes under models folder (this replaces StandardTests.cpp).
# The original StandardTests.cpp also tested additional folders:
# - "killers" with testInCorrectFile
# - "slackers" with testOutOfSpecFile
# However, those folders are not in the repository.
create_file_test("models" "testCorrectFile" false "incorrect")
# bug039.iv and bug055-5.iv contain errors but load anyway: ignore for now
create_file_test("models/io/incorrect" "testIncorrectFile" true "(bug039|bug055-5)")

# Include all extracted '*Tests.cpp' files in the target.
FILE(GLOB COIN_TEST_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/*Test.cpp")

add_executable(CoinTests TestSuiteMain.cpp TestSuiteUtils.cpp TestSuiteMisc.cpp ${COIN_TEST_SOURCES})
target_link_libraries(CoinTests Coin ${COIN_TARGET_LINK_LIBRARIES})
target_include_directories(CoinTests PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/include
	${CMAKE_SOURCE_DIR}/include/Inventor/annex
	${CMAKE_BINARY_DIR}/include
)
if (USE_PTHREAD)
	target_link_libraries(CoinTests pthread)
endif()
add_test(NAME CoinTests COMMAND CoinTests)

# Many warnings are generated from test macros on macOS with Xcode.
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wtautological-compare DISABLE_WARNING_TAUTOLOGCOMPARE)
if(DISABLE_WARNING_TAUTOLOGCOMPARE)
	target_compile_options(CoinTests PUBLIC -Wno-tautological-compare)
endif()

=== include/Inventor/CMakeLists.txt ===
add_subdirectory(C)
add_subdirectory(system)
file(GLOB_RECURSE HDRS *.h)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${HDRS}
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== src/details/CMakeLists.txt ===
# source files
set(COIN_DETAILS_FILES
	SoDetail.cpp
	SoConeDetail.cpp
	SoCubeDetail.cpp
	SoCylinderDetail.cpp
	SoFaceDetail.cpp
	SoLineDetail.cpp
	SoNodeKitDetail.cpp
	SoPointDetail.cpp
	SoTextDetail.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_DETAILS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} details/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(details OBJECT ${COIN_DETAILS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_DETAILS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/details/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/doc/CMakeLists.txt ===
# Add a target to generate API documentation with Doxygen
if(COIN_BUILD_DOCUMENTATION)
  find_package(Doxygen)
  if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
  endif()

# ############################################################################
# Setup documentation options
# ############################################################################
  set(GENERATE_HTMLHELP NO)
  set(DOXYGEN_GENERATE_MAN NO)
  set(GENERATE_QHP NO)
  set(GENERATE_TREEVIEW YES)
  set(HHC_PROGRAM)
  if(WIN32)
    if(COIN_BUILD_DOCUMENTATION_CHM)
      find_program(HHC_PROGRAM NAMES hhc.exe PATHS "C:/Program Files/HTML Help Workshop" "C:/Program Files (x86)/HTML Help Workshop" DOC "HTML Help Compiler program")
      if(NOT HHC_PROGRAM)
        message(FATAL_ERROR "Missing program HTML Help Compiler")
      else()
        set(GENERATE_HTMLHELP YES)
        set(GENERATE_TREEVIEW NO)
        mark_as_advanced(HHC_PROGRAM)
      endif()
    endif()
  else()
    if(COIN_BUILD_DOCUMENTATION_MAN)
      set(DOXYGEN_GENERATE_MAN YES)
    endif()
  endif()
  if(COIN_BUILD_DOCUMENTATION_QTHELP)
    find_program(QHG_LOCATION NAMES qhelpgenerator qhelpgenerator-qt5 DOC "Qt qhelpgenerator")
    if(NOT QHG_LOCATION)
      message(FATAL_ERROR "Missing program Qt qhelpgenerator")
    else()
      set(GENERATE_QHP YES)
      mark_as_advanced(QHG_LOCATION)
    endif()
  endif()

  # Add default files
  file(GLOB_RECURSE DOX *.dox*)
  set(COIN_DOCUMENTATION_FILES
    ${COIN_DOCUMENTATION_FILES}
    "${CMAKE_SOURCE_DIR}/docs/releases.dox"
    ${DOX}
    CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
  )

  set(DOXYGEN_INTERNAL_DOCS NO)
  set(DOXYGEN_EXTRACT_PRIVATE NO)
  set(DOXYGEN_WARN_IF_UNDOCUMENTED YES)
  set(DOXYGEN_EXCLUDE)
  if(COIN_BUILD_INTERNAL_DOCUMENTATION)
    set(DOXYGEN_INTERNAL_DOCS YES)
    set(DOXYGEN_EXTRACT_PRIVATE YES)
    set(DOXYGEN_WARN_IF_UNDOCUMENTED NO)
    set(COIN_DOCUMENTATION_FILES
      ${COIN_DOCUMENTATION_FILES}
      ${COIN_INTERNAL_DOCUMENTATION_FILES}
      CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
    )
  else()
    set(COIN_DOCUMENTATION_EXCLUDE_SYMBOLS SoProfilerP)
    foreach(XF ${COIN_INTERNAL_DOCUMENTATION_FILES})
      set(DOXYGEN_EXCLUDE "${DOXYGEN_EXCLUDE}                         ${XF} \\\n")
    endforeach()
  endif()
  set(DOXYGEN_INPUT)
  list(REMOVE_DUPLICATES COIN_DOCUMENTATION_FILES)
  foreach(XF ${COIN_DOCUMENTATION_FILES})
    set(DOXYGEN_INPUT "${DOXYGEN_INPUT}                         ${XF} \\\n")
  endforeach()
  set(DOXYGEN_INPUT "${DOXYGEN_INPUT}                         ${CMAKE_SOURCE_DIR}/src/tidbits.cpp")
  set(DOXYGEN_EXCLUDE_SYMBOLS)
  foreach(XF ${COIN_DOCUMENTATION_EXCLUDE_SYMBOLS})
    set(DOXYGEN_EXCLUDE_SYMBOLS "${DOXYGEN_EXCLUDE_SYMBOLS}                         ${XF} \\\n")
  endforeach()

  set(DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")
  set(DOXYGEN_OUTPUT "${CMAKE_BINARY_DIR}/html/index.html")
  configure_file("${CMAKE_SOURCE_DIR}/docs/coin.doxygen.cmake.in" ${DOXYFILE} @ONLY)

# ############################################################################
# Setup documentation targets
# ############################################################################
  add_custom_command(
    OUTPUT ${DOXYGEN_OUTPUT}
    COMMAND ${CMAKE_COMMAND} -E echo_append "Generating API documentation with Doxygen "
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
    COMMAND ${CMAKE_COMMAND} -E echo "done."
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${DOXYFILE}
  )
  add_custom_target(documentation ALL DEPENDS ${DOXYGEN_OUTPUT})

# ############################################################################
# Install built documentation files
# ############################################################################
  install(DIRECTORY "${CMAKE_BINARY_DIR}/html" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation REGEX ".*\\.(chm|qch)" EXCLUDE)
  if(GENERATE_HTMLHELP)
    install(FILES "${CMAKE_BINARY_DIR}/html/${PROJECT_NAME}.chm" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)
  endif()
  if(GENERATE_QHP)
    install(FILES "${CMAKE_BINARY_DIR}/html/${PROJECT_NAME}.qch" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)
  endif()
  if(DOXYGEN_GENERATE_MAN)
    install(DIRECTORY "${CMAKE_BINARY_DIR}/man/man3" DESTINATION ${CMAKE_INSTALL_MANDIR} COMPONENT documentation)
    message(STATUS "CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_MANDIR}")
  endif()
endif()

=== src/misc/CMakeLists.txt ===
# source files
set(COIN_MISC_FILES
	AudioTools.cpp
	CoinStaticObjectInDLL.cpp
	SoAudioDevice.cpp
	SoBase.cpp
	SoBaseP.cpp
	SoChildList.cpp
	SoCompactPathList.cpp
	SoConfigSettings.cpp
	SoContextHandler.cpp
	SoDB.cpp
	SoDebug.cpp
	SoFullPath.cpp
	SoGenerate.cpp
	SoGlyph.cpp
	SoInteraction.cpp
	SoJavaScriptEngine.cpp
	SoLightPath.cpp
	SoLockManager.cpp
	SoNormalGenerator.cpp
	SoNotRec.cpp
	SoNotification.cpp
	SoPath.cpp
	SoPick.cpp
	SoPickedPoint.cpp
	SoPrimitiveVertex.cpp
	SoProto.cpp
	SoProtoInstance.cpp
	SoSceneManager.cpp
	SoSceneManagerP.cpp
	SoShaderGenerator.cpp
	SoState.cpp
	SoTempPath.cpp
	SoType.cpp
	CoinResources.cpp
	SoDBP.cpp
	SoEventManager.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_MISC_INTERNAL_FILES
	AudioTools.h
	AudioTools.cpp
	CoinStaticObjectInDLL.h
	CoinStaticObjectInDLL.cpp
	SbHash.h
	SoBaseP.h
	SoBaseP.cpp
	SoCompactPathList.h
	SoCompactPathList.cpp
	SoConfigSettings.h
	SoConfigSettings.cpp
	SoDBP.h
	SoDBP.cpp
	SoGenerate.h
	SoGenerate.cpp
	SoPick.h
	SoPick.cpp
	SoSceneManagerP.h
	SoSceneManagerP.cpp
	SoShaderGenerator.h
	SoShaderGenerator.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_MISC_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} misc/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(misc OBJECT ${COIN_MISC_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_MISC_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/misc/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_MISC_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/misc/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== include/Inventor/C/CMakeLists.txt ===
configure_file(basic.h.cmake.in basic.h)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basic.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Inventor/C COMPONENT development)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${CMAKE_CURRENT_BINARY_DIR}/basic.h
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== include/Inventor/system/CMakeLists.txt ===
if(WIN32)
    set(SIM_INCLUDE_WINDOWS_H "#include <windows.h>")
endif()
if(APPLE)
    set(SIM_INCLUDE_GL_H "#include <OpenGL/gl.h>")
else()
    set(SIM_INCLUDE_GL_H "#include <GL/gl.h>")
endif()
configure_file(gl-headers.h.cmake.in gl-headers.h)
configure_file(inttypes.h.cmake.in inttypes.h)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gl-headers.h ${CMAKE_CURRENT_BINARY_DIR}/inttypes.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Inventor/system COMPONENT development)

## coin3 3.1.4~abc9f50

=== debian/changelog ===
coin3 (3.1.4~abc9f50-7) unstable; urgency=medium

  * [7511871] Add missing libs to autopkgtest.

 -- Anton Gladky <gladk@debian.org>  Thu, 29 May 2014 21:05:59 +0200

coin3 (3.1.4~abc9f50-6) unstable; urgency=medium

  * [a71ca9d] Fix linkage in autopkgtests.

 -- Anton Gladky <gladk@debian.org>  Fri, 23 May 2014 21:34:00 +0200

coin3 (3.1.4~abc9f50-5) unstable; urgency=medium

  * [016c008] Add autopkgtests.
  * [af540e5] Set Standards-Version: 3.9.5. No changes.
  * [1347143] Set canonical VCS-fields.

 -- Anton Gladky <gladk@debian.org>  Sat, 10 May 2014 22:48:22 +0200

coin3 (3.1.4~abc9f50-4) unstable; urgency=low

  * [5c22b46] Update homepage.
  * [86b198d] Build with autotools_dev. (Closes: #727344)
  * [2d528b8] Add --enable-threadsafe to config options. (Closes: #723567)
  * [ccaf381] Remove some odd manpages.

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Oct 2013 20:58:14 +0200

coin3 (3.1.4~abc9f50-3) unstable; urgency=low

  * [3637e37] Rename mans for string.h and thread.h. (Closes: #710213)

 -- Anton Gladky <gladk@debian.org>  Wed, 29 May 2013 19:56:12 +0200

coin3 (3.1.4~abc9f50-2) unstable; urgency=low

  * Move the package from experimental to unstable.

 -- Anton Gladky <gladk@debian.org>  Tue, 28 May 2013 21:26:01 +0200

coin3 (3.1.4~abc9f50-1) experimental; urgency=low

  * [7757fb9] Imported Upstream version 3.1.4~abc9f50
  * [638d7fc] Update copyright file. The license is changed to BSD.
  * [e056c3e] Remove creating html/dynsections.js.
  * [021cded] Update binary-names. Use multiarch.

 -- Anton Gladky <gladk@debian.org>  Sun, 14 Apr 2013 14:22:54 +0200

coin3 (3.1.3-3~exp1) experimental; urgency=low

  * [bac6081] Switch to dpkg-source 3.0 (quilt) format
  * [0051dcd] Update watch-file. Thanks to Bart Martens <bartm@debian.org>.
  * [4f64bb1] Update copyright-file to DEP-5.
  * [4a78846] Switch VCS to git.
  * [8398847] Convert patch to quilt-format.
  * [b98daa0] Clean debian/rules. Use .install-files.
  * [ace5108] Use dh 9, Standards-Version 3.9.4. No multi-arch support yet.
  * [c7e12ca] Add myself to uploaders.
  * [216f542] Update changelog.
  * [7b606c3] Remove Steve M. Robbins from uploaders.
  * [55c8751] Use wrap-and-sort for formatting.

 -- Anton Gladky <gladk@debian.org>  Tue, 05 Mar 2013 21:23:49 +0100

coin3 (3.1.3-2.2) unstable; urgency=low

  * Non maintainer upload
  * Stop building with -fpermissive, add missing includes. Closes: #667375.

 -- Matthias Klose <doko@debian.org>  Wed, 23 May 2012 22:49:10 +0000

coin3 (3.1.3-2.1) unstable; urgency=low

  * Non-maintainer upload.

  [ Gregor Herrmann ]
  * Fix "ftbfs with GCC-4.7": build with -fpermissive, thanks to Matthias
    Klose for the pointer.
    (Closes: #667139)

  [ Matthias Klose ]
  * Overwrite lintian warning for embedded library for this upload.

 -- gregor herrmann <gregoa@debian.org>  Sun, 13 May 2012 15:39:08 +0200

coin3 (3.1.3-2) unstable; urgency=low

  * control: Remove dependencies on libxp-dev, which is to be obsoleted.
    Closes: #623647.

  * control: Move to Debian-science repository, set Maintainer, Uploaders,
    and Vcs fields.
  
  * rules: rewrite using dh.
  * control: Remove build-dep on cdbs, quilt; add autotools-dev.  
    Set debhelper version to >= 8.  Update Standards-Version.
  * compat: New.  Set to 8.

 -- Steve M. Robbins <smr@debian.org>  Fri, 22 Apr 2011 23:18:15 -0500

coin3 (3.1.3-1) unstable; urgency=low

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Tue, 23 Mar 2010 20:36:32 -0500

coin3 (3.1.2-1) unstable; urgency=low

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 01 Nov 2009 20:48:59 -0600

coin3 (3.1.0-2) unstable; urgency=low

  * rules: Don't install manpage deprecated.3.  Closes: #533228.

 -- Steve M. Robbins <smr@debian.org>  Mon, 29 Jun 2009 23:39:44 -0500

coin3 (3.1.0-1) unstable; urgency=low

  * New upstream release.

 -- Steve M. Robbins <smr@debian.org>  Fri, 12 Jun 2009 21:49:23 -0500

coin3 (3.0.0-1) unstable; urgency=low

  * New upstream release.

 -- Steve M. Robbins <smr@debian.org>  Sat, 11 Oct 2008 00:46:03 -0500

coin2 (2.5.0-2) unstable; urgency=low

  * debian/control: Change suggests from libopenal0 to libopenal0a.
    Closes: #488001.  Change ${Source-Version} to ${binary:Version}.
    Update to standards version 3.8.0.
  
  * debian/rules: Do not ignore errors in clean rule.

 -- Steve M. Robbins <smr@debian.org>  Sat, 28 Jun 2008 02:38:17 -0500

coin2 (2.5.0-1) unstable; urgency=low

  * New upstream.  Closes: #444848.

 -- Steve M. Robbins <smr@debian.org>  Sun, 04 Nov 2007 15:14:38 -0600

coin2 (2.4.6-2) unstable; urgency=low

  * debian/control: Adapt build-depends to the latest churn of x11
    packages.  Package libcoin20-dev now depends on all relevant X11 -dev
    packages.

 -- Steve M. Robbins <smr@debian.org>  Sat, 22 Sep 2007 19:13:09 -0500

coin2 (2.4.6-1) unstable; urgency=low

  * New upstream.  Closes: #417616.
  
  * debian/rules: Install coin.m4.  Closes: #421683.

 -- Steve M. Robbins <smr@debian.org>  Wed,  2 May 2007 00:56:48 -0500

coin2 (2.4.5-3) unstable; urgency=low

  * debian/control: Suggest libsimage-dev to enable loading image files
  using SbImage.  Closes: #414657.  Bump Standards-Version to 3.7.2.2
  (no changes required).
  
  * debian/watch: New.
  
  * debian/rules: Remove bogus man/man?/_* files before packaging.

 -- Steve M. Robbins <smr@debian.org>  Wed, 14 Mar 2007 21:08:33 -0500

coin2 (2.4.5-2) unstable; urgency=low

  * debian/control: build-depend on libglu1-mesa-dev.  Closes: #365601.

 -- Steve M. Robbins <smr@debian.org>  Mon,  1 May 2006 20:59:33 -0400

coin2 (2.4.5-1) unstable; urgency=low

  * New upstream version.
    Removed excess qualification on method definition.  Closes: #357190.

 -- Steve M. Robbins <smr@debian.org>  Sun, 30 Apr 2006 16:58:52 -0400

coin2 (2.4.4-2) unstable; urgency=low

  * debian/control: Replace build-dependency on xlibs-dev with 8 others.
    This is progress, apparently.  Closes: #346642.



=== debian/control ===
Source: coin3
Section: graphics
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>
Priority: optional
Build-Depends:
 debhelper (>= 9),
 autotools-dev,
 doxygen,
 libgl1-mesa-dev,
 libx11-dev,
 libxext-dev,
 libxi-dev,
 libxmu-dev,
 libxpm-dev,
 libxt-dev,
 libboost-all-dev
Standards-Version: 3.9.5
Homepage: https://bitbucket.org/Coin3D/coin/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/coin3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/coin3.git
XS-Testsuite: autopkgtest

Package: libcoin80
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests:
 libbz2-1.0,
 libfreetype6,
 libopenal0a,
 libsimage-dev,
 zlib1g
Description: high-level 3D graphics kit implementing the Open Inventor API
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.  Installing the suggested packages will enable
 extra features:
 .
     libsimage-dev enables loading of image files in SbImage
     libfreetype6 enables use of TrueType fonts
     libopenal0a   enables audio support
     zlib1g and libbz2 enable transparent read of compressed files

Package: libcoin80-dev
Architecture: any
Section: libdevel
Depends:
 libcoin80 (= ${binary:Version}),
 libgl1-mesa-dev | libgl-dev,
 libx11-dev,
 libxext-dev,
 libxi-dev,
 libxmu-dev,
 libxpm-dev,
 libxt-dev,
 ${misc:Depends}
Suggests:
 libcoin80-doc (= ${binary:Version})
Conflicts:
 inventor-dev,
 libcoin20-dev,
 libcoin40-dev,
 libcoin60-dev
Description: high-level 3D graphics devkit with Open Inventor and VRML97 support
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin80-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Suggests:
 libcoin80-dev (= ${binary:Version})
Conflicts:
 inventor-dev,
 libcoin20-doc,
 libcoin40-doc,
 libcoin60-doc
Description: high-level 3D graphics kit with Open Inventor and VRML97 support
 API documentation for the Coin library (the Open Inventor API) in
 manpage and HTML format.

Package: libcoin80-runtime
Architecture: all
Section: libs
Depends:
 ${misc:Depends}
Suggests:
 libcoin80
Conflicts:
 libcoin20-runtime,
 libcoin40-runtime,
 libcoin60-runtime
Description: high-level 3D graphics kit - external data files
 External data files used by the Coin library at run-time.  The
 dragger geometry files represent the defaults that are used if the
 files are not found.  This package is completely optional.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autotools_dev

DEB_CONFIGURE_EXTRA_FLAGS = --disable-dependency-tracking \
	--enable-static --enable-shared \
	--disable-maintainer-mode \
	--enable-html htmldir=/usr/share/doc/libcoin80-doc/html \
	--enable-man --mandir=/usr/share/man \
	--without-mesa \
	--enable-threadsafe \

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_installman:
	mv $(CURDIR)/debian/tmp/usr/share/man/man3/string.h.3 $(CURDIR)/debian/tmp/usr/share/man/man3/string_coin.h.3
	mv $(CURDIR)/debian/tmp/usr/share/man/man3/thread.h.3 $(CURDIR)/debian/tmp/usr/share/man/man3/thread_coin.h.3
	rm -rf $(CURDIR)/debian/tmp/usr/share/man/man3/_*.*.*
	dh_installman

## coin3 3.1.4~abc9f50%2Bdfsg1

=== debian/changelog ===
coin3 (3.1.4~abc9f50+dfsg1-1) unstable; urgency=medium

  * [512fe7c] Add cfg/*.exe to Files-Exclude. (Closes: #795241)
  * [34acbce] Imported Upstream version 3.1.4~abc9f50+dfsg1
  * [c0af329] Update d/copyright. (Closes: #795242)

 -- Anton Gladky <gladk@debian.org>  Wed, 12 Aug 2015 15:17:11 +0200

coin3 (3.1.4~abc9f50-10) unstable; urgency=medium

  * [c2c2387] Rename libcoin80 due to GCC-5 transition. (Closes: #791005)

 -- Anton Gladky <gladk@debian.org>  Tue, 11 Aug 2015 17:09:22 +0200

coin3 (3.1.4~abc9f50-9) unstable; urgency=medium

  * [9b6129c] Disable manpage generation
  * [fc10ff3] Fix the license name.
  * [f89e224] Apply fix cme dpkg-copyright.

 -- Anton Gladky <gladk@debian.org>  Wed, 10 Jun 2015 21:04:42 +0200

coin3 (3.1.4~abc9f50-8) unstable; urgency=medium

  * [f1342f6] Remove timestamp in generated html.
  * [87063f6] Set Standards-Version: 3.9.6. No changes.
  * [f99a2ec] Use cme fix dpkg-control.

 -- Anton Gladky <gladk@debian.org>  Tue, 05 May 2015 22:18:27 +0200

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autotools_dev

DEB_CONFIGURE_EXTRA_FLAGS = --disable-dependency-tracking \
	--enable-static --enable-shared \
	--disable-maintainer-mode \
	--enable-html htmldir=/usr/share/doc/libcoin80-doc/html \
	--without-mesa \
	--enable-threadsafe \

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

## coin3 3.1.4~abc9f50+dfsg1

=== debian/changelog ===
coin3 (3.1.4~abc9f50+dfsg1-2) unstable; urgency=medium

  [ Francesco Poli ]
  * [832d33b] Fix d/copyright. (Closes: #824711)

  [ Anton Gladky ]
  * [fd84979] Apply cme fix dpkg.
  * [81f0d54] Activate ldconfig trigger.

 -- Anton Gladky <gladk@debian.org>  Fri, 20 May 2016 19:59:43 +0200

=== debian/control ===
Source: coin3
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: graphics
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 9),
               autotools-dev,
               doxygen,
               libgl1-mesa-dev,
               libx11-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               libxpm-dev,
               libxt-dev,
               libboost-all-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/coin3.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/coin3.git
Homepage: https://bitbucket.org/Coin3D/coin/

Package: libcoin80v5
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libbz2-1.0,
          libfreetype6,
          libopenal0a,
          libsimage-dev,
          zlib1g
Pre-Depends: ${misc:Pre-Depends}
Breaks: libcoin80
Replaces: libcoin80
Description: high-level 3D graphics kit implementing the Open Inventor API
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.  Installing the suggested packages will enable
 extra features:
 .
     libsimage-dev enables loading of image files in SbImage
     libfreetype6 enables use of TrueType fonts
     libopenal0a   enables audio support
     zlib1g and libbz2 enable transparent read of compressed files

Package: libcoin80-dev
Architecture: any
Section: libdevel
Depends: libcoin80v5 (= ${binary:Version}),
         libgl1-mesa-dev | libgl-dev,
         libx11-dev,
         libxext-dev,
         libxi-dev,
         libxmu-dev,
         libxpm-dev,
         libxt-dev,
         ${misc:Depends}
Suggests: libcoin80-doc (= ${binary:Version})
Conflicts: inventor-dev,
           libcoin20-dev,
           libcoin40-dev,
           libcoin60-dev
Description: high-level 3D graphics devkit with Open Inventor and VRML97 support
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin80-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libcoin80-dev (= ${binary:Version})
Conflicts: inventor-dev,
           libcoin20-doc,
           libcoin40-doc,
           libcoin60-doc
Description: high-level 3D graphics kit with Open Inventor and VRML97 support
 API documentation for the Coin library (the Open Inventor API) in
 manpage and HTML format.

Package: libcoin80-runtime
Architecture: all
Section: libs
Depends: ${misc:Depends}
Suggests: libcoin80v5
Conflicts: libcoin20-runtime,
           libcoin40-runtime,
           libcoin60-runtime
Description: high-level 3D graphics kit - external data files
 External data files used by the Coin library at run-time.  The
 dragger geometry files represent the defaults that are used if the
 files are not found.  This package is completely optional.

## coin3 3.1.4~abc9f50+dfsg2

=== debian/changelog ===
coin3 (3.1.4~abc9f50+dfsg2-1) unstable; urgency=medium

  * Team upload.
  * [e1dfea6] Remove an embedded version of expat. (Closes: #874727)
  * [6fa83c5] Use compat level 10
  * [abf1040] Ignore files src/xml/expat in d/copyright
  * [7c4d8f0] New upstream version 3.1.4~abc9f50+dfsg2
  * [d61c626] Apply cme fix dpkg
  * [9d48f66] Remove myself from uploaders

 -- Anton Gladky <gladk@debian.org>  Wed, 20 Dec 2017 21:45:35 +0100
